local function Create_Update_Macro_Covenant(self, event, ...)
	C_Timer.After(2, function()

		local _GSInfo		= GetSpellInfo
		local className		= UnitClassBase("player")
		local covenantID	= C_Covenants.GetActiveCovenantID()

		local MacroSettings = {
			["CLASS"] = {
				["Name"] = "@CClass",
				["Body"] = "#showtooltip\n/cast $replacespellname",
			},
			["SIGNATURE"] = {
				["Name"] = "@CSignature",
				["Body"] = "#showtooltip\n/cast $replacespellname",
			},
		}

		local CovenantSpellAbilityByClass = {
			["WARRIOR"] = {
				[0] = nil,								-- None
				[1] = {									-- Kyrian
					["CLASS"] = _GSInfo(307865),		-- Spear of Bastion
					["SIGNATURE"] = _GSInfo(324739),	-- Summon Steward
				},
				[2] = {									-- Venthyr
					["CLASS"] = _GSInfo(317349),		-- Condemn
					["SIGNATURE"] = _GSInfo(300728),	-- Door of Shadows
				},
				[3] = {									-- NightFae
					["CLASS"] = _GSInfo(325886),		-- Ancient Aftershock
					["SIGNATURE"] = _GSInfo(310143),	-- Soulshape
				},
				[4] = {									-- Necrolord
					["CLASS"] = _GSInfo(324143),		-- Conqueror's Banner
					["SIGNATURE"] = _GSInfo(331180),	-- Fleshcraft
				},
			},
			["PALADIN"] = {
				[0] = nil,								-- None
				[1] = {									-- Kyrian
					["CLASS"] = _GSInfo(304971),		-- Divine Toll
					["SIGNATURE"] = _GSInfo(324739),	-- Summon Steward
				},
				[2] = {									-- Venthyr
					["CLASS"] = _GSInfo(316958),		-- Ashen Hallow
					["SIGNATURE"] = _GSInfo(300728),	-- Door of Shadows
				},
				[3] = {									-- NightFae
					["CLASS"] = _GSInfo(328278),		-- Blessing of the Seasons
					["SIGNATURE"] = _GSInfo(310143),	-- Soulshape
				},
				[4] = {									-- Necrolord
					["CLASS"] = _GSInfo(328204),		-- Vanquisher's Hammer
					["SIGNATURE"] = _GSInfo(331180),	-- Fleshcraft
				},
			},
			["HUNTER"] = {
				[0] = nil,								-- None
				[1] = {									-- Kyrian
					["CLASS"] = _GSInfo(308491),		-- Resonating Arrow
					["SIGNATURE"] = _GSInfo(324739),	-- Summon Steward
				},
				[2] = {									-- Venthyr
					["CLASS"] = _GSInfo(324149),		-- Flayed Shot
					["SIGNATURE"] = _GSInfo(300728),	-- Door of Shadows
				},
				[3] = {									-- NightFae
					["CLASS"] = _GSInfo(328231),		-- Wild Spirits
					["SIGNATURE"] = _GSInfo(310143),	-- Soulshape
				},
				[4] = {									-- Necrolord
					["CLASS"] = _GSInfo(325028),		-- Death Chakram
					["SIGNATURE"] = _GSInfo(331180),	-- Fleshcraft
				},
			},
			["ROGUE"] = {
				[0] = nil,								-- None
				[1] = {									-- Kyrian
					["CLASS"] = _GSInfo(323547),		-- Echoing Reprimand
					["SIGNATURE"] = _GSInfo(324739),	-- Summon Steward
				},
				[2] = {									-- Venthyr
					["CLASS"] = _GSInfo(323654),		-- Flagellation
					["SIGNATURE"] = _GSInfo(300728),	-- Door of Shadows
				},
				[3] = {									-- NightFae
					["CLASS"] = _GSInfo(328305),		-- Sepsis
					["SIGNATURE"] = _GSInfo(310143),	-- Soulshape
				},
				[4] = {									-- Necrolord
					["CLASS"] = _GSInfo(328547),		-- Serrated Bone Spike
					["SIGNATURE"] = _GSInfo(331180),	-- Fleshcraft
				},
			},
			["PRIEST"] = {
				[0] = nil,								-- None
				[1] = {									-- Kyrian
					["CLASS"] = _GSInfo(325013),		-- Boon of the Ascended
					["SIGNATURE"] = _GSInfo(324739),	-- Summon Steward
				},
				[2] = {									-- Venthyr
					["CLASS"] = _GSInfo(323673),		-- Mindgames
					["SIGNATURE"] = _GSInfo(300728),	-- Door of Shadows
				},
				[3] = {									-- NightFae
					["CLASS"] = _GSInfo(327661),		-- Fae Guardians
					["SIGNATURE"] = _GSInfo(310143),	-- Soulshape
				},
				[4] = {									-- Necrolord
					["CLASS"] = _GSInfo(324724),		-- Unholy Nova
					["SIGNATURE"] = _GSInfo(331180),	-- Fleshcraft
				},
			},
			["DEATHKNIGHT"] = {
				[0] = nil,								-- None
				[1] = {									-- Kyrian
					["CLASS"] = _GSInfo(312202),		-- Shackle the Unworthy
					["SIGNATURE"] = _GSInfo(324739),	-- Summon Steward
				},
				[2] = {									-- Venthyr
					["CLASS"] = _GSInfo(311648),		-- Swarming Mist
					["SIGNATURE"] = _GSInfo(300728),	-- Door of Shadows
				},
				[3] = {									-- NightFae
					["CLASS"] = _GSInfo(324128),		-- Death's Due
					["SIGNATURE"] = _GSInfo(310143),	-- Soulshape
				},
				[4] = {									-- Necrolord
					["CLASS"] = _GSInfo(315443),		-- Abomination Limb
					["SIGNATURE"] = _GSInfo(331180),	-- Fleshcraft
				},
			},
			["SHAMAN"] = {
				[0] = nil,								-- None
				[1] = {									-- Kyrian
					["CLASS"] = _GSInfo(324386),		-- Vesper Totem
					["SIGNATURE"] = _GSInfo(324739),	-- Summon Steward
				},
				[2] = {									-- Venthyr
					["CLASS"] = _GSInfo(320674),		-- Chain Harvest
					["SIGNATURE"] = _GSInfo(300728),	-- Door of Shadows
				},
				[3] = {									-- NightFae
					["CLASS"] = _GSInfo(328923),		-- Fae Transfusion
					["SIGNATURE"] = _GSInfo(310143),	-- Soulshape
				},
				[4] = {									-- Necrolord
					["CLASS"] = _GSInfo(326059),		-- Primordial Wave
					["SIGNATURE"] = _GSInfo(331180),	-- Fleshcraft
				},
			},
			["MAGE"] = {
				[0] = nil,								-- None
				[1] = {									-- Kyrian
					["CLASS"] = _GSInfo(307443),		-- Radiant Spark
					["SIGNATURE"] = _GSInfo(324739),	-- Summon Steward
				},
				[2] = {									-- Venthyr
					["CLASS"] = _GSInfo(314793),		-- Mirrors of Torment
					["SIGNATURE"] = _GSInfo(300728),	-- Door of Shadows
				},
				[3] = {									-- NightFae
					["CLASS"] = _GSInfo(314791),		-- Shifting Power
					["SIGNATURE"] = _GSInfo(310143),	-- Soulshape
				},
				[4] = {									-- Necrolord
					["CLASS"] = _GSInfo(324220),		-- Deathborne
					["SIGNATURE"] = _GSInfo(331180),	-- Fleshcraft
				},
			},
			["WARLOCK"] = {
				[0] = nil,								-- None
				[1] = {									-- Kyrian
					["CLASS"] = _GSInfo(312321),		-- Scouring Tithe
					["SIGNATURE"] = _GSInfo(324739),	-- Summon Steward
				},
				[2] = {									-- Venthyr
					["CLASS"] = _GSInfo(321792),		-- Impending Catastrophe
					["SIGNATURE"] = _GSInfo(300728),	-- Door of Shadows
				},
				[3] = {									-- NightFae
					["CLASS"] = _GSInfo(325640),		-- Soul Rot
					["SIGNATURE"] = _GSInfo(310143),	-- Soulshape
				},
				[4] = {									-- Necrolord
					["CLASS"] = _GSInfo(325289),		-- Decimating Bolt
					["SIGNATURE"] = _GSInfo(331180),	-- Fleshcraft
				},
			},
			["MONK"] = {
				[0] = nil,								-- None
				[1] = {									-- Kyrian
					["CLASS"] = _GSInfo(310454),		-- Weapons of Order
					["SIGNATURE"] = _GSInfo(324739),	-- Summon Steward
				},
				[2] = {									-- Venthyr
					["CLASS"] = _GSInfo(326860),		-- Fallen Order
					["SIGNATURE"] =_GSInfo( 300728),	-- Door of Shadows
				},
				[3] = {									-- NightFae
					["CLASS"] = _GSInfo(327104),		-- Faeline Stomp
					["SIGNATURE"] = _GSInfo(310143),	-- Soulshape
				},
				[4] = {									-- Necrolord
					["CLASS"] = _GSInfo(325216),		-- Bonedust Brew
					["SIGNATURE"] = _GSInfo(331180),	-- Fleshcraft
				},
			},
			["DRUID"] = {
				[0] = nil,								-- None
				[1] = {									-- Kyrian
					["CLASS"] = _GSInfo(326434),		-- Kindred Spirits
					["SIGNATURE"] = _GSInfo(324739),	-- Summon Steward
				},
				[2] = {									-- Venthyr
					["CLASS"] = _GSInfo(323546),		-- Ravenous Frenzy
					["SIGNATURE"] =_GSInfo( 300728),	-- Door of Shadows
				},
				[3] = {									-- NightFae
					["CLASS"] = _GSInfo(323764),		-- Convoke the Spirits
					["SIGNATURE"] = _GSInfo(310143),	-- Soulshape
				},
				[4] = {									-- Necrolord
					["CLASS"] = _GSInfo(325727),		-- Adaptive Swarm
					["SIGNATURE"] = _GSInfo(331180),	-- Fleshcraft
				},
			},
			["DEMONHUNTER"] = {
				[0] = nil,								-- None
				[1] = {									-- Kyrian
					["CLASS"] = _GSInfo(306830),		-- Elysian Decree
					["SIGNATURE"] = _GSInfo(324739),	-- Summon Steward
				},
				[2] = {									-- Venthyr
					["CLASS"] = _GSInfo(317009),		-- Sinful Brand
					["SIGNATURE"] =_GSInfo( 300728),	-- Door of Shadows
				},
				[3] = {									-- NightFae
					["CLASS"] = _GSInfo(323639),		-- The Hunt
					["SIGNATURE"] = _GSInfo(310143),	-- Soulshape
				},
				[4] = {									-- Necrolord
					["CLASS"] = _GSInfo(329554),		-- Fodder to the Flame
					["SIGNATURE"] = _GSInfo(331180),	-- Fleshcraft
				},
			},
		}

		if className and ( covenantID > 0 or covenantID <= 4 ) then
			for uid, macro in pairs(MacroSettings) do
				local spellName = CovenantSpellAbilityByClass[className][covenantID][uid]
				local _, _, spellIcon = _GSInfo(spellName)
				local macroSlot = GetMacroIndexByName(macro.Name)
				local macroBody = macro.Body:gsub("$replacespellname", spellName)
				if macroSlot == 0 then
					CreateMacro(macro.Name, spellIcon, macroBody, nil)
				else
					EditMacro(macroSlot, macro.Name, spellIcon, macroBody, 1, 1)
				end
			end
		end

	end)
end

local FrameEvent = CreateFrame("Frame")
FrameEvent:RegisterEvent("PLAYER_ENTERING_WORLD")
FrameEvent:RegisterEvent("COVENANT_CHOSEN")
FrameEvent:SetScript("OnEvent", Create_Update_Macro_Covenant)